
{$APPTYPE GUI}{$MODE DELPHI}

program DemoGenericVegetation;

uses
  {SysUtils,}windows,math,gl,glu,GraphOGL,GOGL_SimplePlants_Ext1;

//const
 
//type
  
var 
  tree:array[0..3]of gluint;

   
//{$R *.rc}
//{$R *.res}  


procedure Quad(x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4,tu,tv,alpha:glFloat);
begin
  TwoSideON;
  glDisable(GL_CULL_FACE);
  glColor4f(alpha,alpha,alpha,alpha);
  glBegin(GL_QUADS);
   FindNormal(x2,y2,z2,x1,y1,z1,x3,y3,z3);
   glNormal3f(FNormal[1], FNormal[2], FNormal[3]);
	LineFree(1*tu,-1*tv, 0,-1*tv, x2,y2,z2, x1,y1,z1,true);
	LineFree(0,0, 1*tu,0, x3,y3,z3, x4,y4,z4,true);	
  glEnd;
  glEnable(GL_CULL_FACE);
  glColor4f(1,1,1,1);
  TwoSideOFF;  
end;


procedure MatAlbero;
begin
  TextureSelectID(1);
end;
 
procedure MdlFoglieAlbero;
begin
  TextureTGASelectID(0);
  TwoSideON;
  glDisable(GL_CULL_FACE);
  SetglSprite;
  Quad(-1,-1,0, 1,-1,0, -1,1,0, 1,1,0, 1,1, 1);
  SetglSpriteOFF;
  glEnable(GL_CULL_FACE);
  TwoSideOFF;  
end; 

procedure MdlFioreAlbero;
begin
  TextureTGASelectID(1);
  TwoSideON;
  glDisable(GL_CULL_FACE);
  SetglSprite;
  Quad(-0.05,-0.05,0, 0.05,-0.05,0, -0.05,0.05,0, 0.05,0.05,0, 1,1, 1);
  SetglSpriteOFF;
  glEnable(GL_CULL_FACE);
  TwoSideOFF;   
end;

procedure MdlFruttoAlbero;
begin
  TextureSelectID(2);
  Sfera(0,0,0, 0.08, 6,6, 1);  
end;

 
procedure OpenGL_CreateList();

procedure OpenGL_Texture();
begin    
  
  TextureLoadID('Floor05.bmp',0);
  TextureLoadID('corteccia02.bmp',1);
  TextureLoadID('rosso.bmp',2);
  TextureLoadTGAID('acacia.tga',0);
  TextureLoadTGAID('giglio.tga',1);
  
end;
begin 

  OpenGL_Texture();
    
  Tree3AdvancedFractal3D(tree[0],MdlFoglieAlbero,MdlFioreAlbero,MdlFruttoAlbero,MatAlbero,6,3,1,0.8*1.2*6,0.016*1.6*6,true);
  Tree3AdvancedFractal3D(tree[1],MdlFoglieAlbero,ProcNull,ProcNull,MatAlbero,6,3,1,0.8*1.2*6,0.016*1.6*6,false);
  Tree3AdvancedFractal3D(tree[2],MdlFoglieAlbero,MdlFioreAlbero,ProcNull,MatAlbero,6,3,0.07,0.6*1.2*6,0.016*1.6*6,false); 
  Tree3AdvancedFractal3D(tree[3],MdlFoglieAlbero,ProcNull,MdlFruttoAlbero,MatAlbero,6,2,1,0.3*1.2*6,0.016*1.4*6,true); 
 
end;


procedure OpenGL_Draw();

procedure OpenGL_Draw2D();
begin
 
  OpenGL_I2D(0,0,0,0);       // inizializza la grafica 2D 
  
  OpenGL_Init(100,0,0,0,0);  // reimposta la grafica 3D
  
end;
procedure OpenGL_Mouse2D();
begin
  
end;
procedure OpenGL_Keyboard();
begin

end;
begin

  glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();
 
  OpenGL_Draw2D();               // carica gli elementi per la grafica 2d 
  OpenGL_Mouse2D();              // carica i comandi del mause per la grafica 2d
  OpenGL_Keyboard();             // carica i comandi della tastiera
  
  if SetglKey('Z')then glTranslatef(0,-2,-15)
  else glTranslatef(0,-2,-30);        // regola l'inquadratura degli elementi nello schermo
  glRotatef(35,1,0,0); 
  
  SetglMouseMove(GL_M0,2);   
     
  TextureSelectID(0); 
  Quad(-10,0,-10, 10,0,-10, -10,0,10, 10,0,10, 4,4, 1);  
   
  glPushMatrix();
  glTranslatef(-5,0,-4);   
  glCallList(tree[0]);
  glPopMatrix();  
  
  glPushMatrix();
  glTranslatef(5,0,-3);   
  glCallList(tree[1]);
  glPopMatrix();   
  
  glPushMatrix();
  glTranslatef(2.6,0,5);   
  glCallList(tree[2]);
  glPopMatrix();  
 
  glPushMatrix();
  glTranslatef(-3.4,0,6);   
  glCallList(tree[3]);
  glPopMatrix(); 
 
end;

// inizio del programma
begin

 if MessageBox(0,'Settare lo schermo intero?  ', 'Video!',MB_YESNO OR MB_ICONQUESTION) = IDNO 
  then fullscreen := false else fullscreen := true;
  
 OGLWindowSetting(ARROW,'',GENERIC,'');
 CreateOGLWindow('Generatore generico di alberi - z = zoom', 800, 600, 32, fullscreen);// si possono usare anche dei rapporti diversi da 4/3 o 16/9
 OpenGL_Init(100,0,0,0,0);			  // inizializza la grafica OpenGL(consente d'impostare il colore di sfondo e la profondit della visuale) 
 SetglRefractive();                         // imposta la rifrazione ambientale ed elimina le facce interne
 SetglLight(GL_LIGHT0,0.0,0.0,0.0,0.1);     // imposta la luce ambientale
 OpenGL_CreateList();                       // carica le liste degli oggetti (modelli composti)

 // impostare qui i valori delle variabili   

 REPEAT				     // inizio del ciclo principale

 glCLEAR(GL_COLOR_BUFFER_BIT);
 Setglmsg();

 OpenGL_Draw();             // carica gli elementi che devono essere un aggiornati sullo schermo 
 SwapBuffers(dcWindow);	    // abilita la visualizzazione grafica OpenGL

 // inserire qui eventuali dati aggiuntivi

UNTIL active = false;		// fine del ciclo principale (premere ESC per uscire)

 DeleteOGLWindow();		    // chiude la finestra
end.
